<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">

var debug = 1;
var currentStep = 1;
var clusterIsValid = false;

function init()
{
	var frm = document.forms['reggie'];
	var mergedSequences = getMergedSequences();

	if (mergedSequences != null && mergedSequences.length > 0)
	{
		var firstPlate = null;
		for (var msNo=0; msNo < mergedSequences.length; msNo++)
		{
			var ms = mergedSequences[msNo];
			var lib = ms.lib;
			var libPlate = lib.bioWell.bioPlate;
			if (firstPlate == null) firstPlate = libPlate.name;
			
			var name = (msNo+1) + ': ' + libPlate.name + ' - ' + ms.name;
			if (ms.AutoProcess == 'ReProcess')
			{
				name += ' [R]';
			}
			
			var option = new Option(name, ms.id, false, libPlate.name==firstPlate);
			option.mergedSequences = ms;
			frm.mergedSequences.options[frm.mergedSequences.length] = option;
		}
		//sequencingRunOnChange();
	}
	else
	{
		setInputStatus('mergedSequences', 'No new sequences available for processing', 'invalid');
	}

	// All is ok
	frm.mergedSequences.focus();
}

function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	setInnerHTML('gonext.message', '');
	if (currentStep == 1)
	{
		if (step1IsValid()) gotoStep2();
	}
	setCurrentStep(currentStep);
}

function step1IsValid()
{
	var frm = document.forms['reggie'];
	for (var msNo = 0; msNo < frm.mergedSequences.length; msNo++)
	{
		if (frm.mergedSequences[msNo].selected) return true;
	}
	setInputStatus('mergedSequences', 'Select at least one item', 'invalid');
	return false;
}

function step2IsValid()
{

	return true;
}


function getMergedSequences()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading merged sequences runs...');
		var url = '../MaskAlign.servlet?ID=<%=ID%>&cmd=GetMergedSequencesForAlignment';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.mergedSequences;
}


function gotoStep2()
{
	var frm = document.forms['reggie'];
	
	// Disable controls
	frm.mergedSequences.disabled = true;

	currentStep = 2;
	Main.hide('step.1.section');
	Main.show('step.2.section');
	Main.addClass(document.getElementById('step.1.section'), 'disabled');
	Main.show('gocancel');
	Main.show('goregister');
	Main.hide('gonext');
	
	// Load masking protocols
	var maskingProtocols = getProtocols('MASKING_PROTOCOL');
	for (var i = 0; i < maskingProtocols.length; i++)
	{
		var protocol = maskingProtocols[i];
		frm.maskingProtocol[frm.maskingProtocol.length] = new Option(protocol.name, protocol.id, protocol.isDefault);
		setInputStatus('maskingProtocol', '', 'valid');
	}
	if (frm.maskingProtocol.length == 0)
	{
		frm.maskingProtocol[0] = new Option('- none -', '');
	}
	
	// Load masking software
	var software = getSoftware('MASKING_SOFTWARE');
	for (var i = 0; i < software.length; i++)
	{
		var sw = software[i];
		frm.maskingSoftware[frm.maskingSoftware.length] = new Option(sw.name, sw.id, sw.isDefault);
		setInputStatus('maskingSoftware', '', 'valid');
	}
	if (frm.maskingSoftware.length == 0)
	{
		frm.maskingSoftware[0] = new Option('- none -', '');
	}
	
	// Load clusters
	var clusters = getClusters();
	for (var i = 0; i < clusters.length; i++)
	{
		var cl = clusters[i];
		var option = new Option(cl.name, cl.id);
		option.cluster = cl;
		frm.clusters[frm.clusters.length] = option;
		setInputStatus('clusters', '', 'valid');
		clusterIsValid = true;
	}
	if (frm.clusters.length == 0)
	{
		setInputStatus('clusters', 'No available Open Grid clusters', 'invalid');
		clusterIsValid = false;
	}
	else
	{
		clusterOnChange();
	}
	// Check debug by default if debug is set or not on a secure server (=production server)
	frm.debug.checked = debug || location.protocol != 'https:';
	
	// Load align protocols
	var alignProtocols = getProtocols('ALIGNMENT_PROTOCOL');
	for (var i = 0; i < alignProtocols.length; i++)
	{
		var protocol = alignProtocols[i];
		frm.alignProtocol[frm.alignProtocol.length] = new Option(protocol.name, protocol.id, protocol.isDefault);
		setInputStatus('alignProtocol', '', 'valid');
	}
	if (frm.alignProtocol.length == 0)
	{
		frm.alignProtocol[0] = new Option('- none -', '');
	}
	
	// Load align software
	var software = getSoftware('ALIGNMENT_SOFTWARE');
	for (var i = 0; i < software.length; i++)
	{
		var sw = software[i];
		frm.alignSoftware[frm.alignSoftware.length] = new Option(sw.name, sw.id, sw.isDefault);
		setInputStatus('alignSoftware', '', 'valid');
	}
	if (frm.alignSoftware.length == 0)
	{
		frm.alignSoftware[0] = new Option('- none -', '');
	}

}

function getProtocols(subtype)
{
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading ' + subtype + ' protocols...');
		var url = '../Protocol.servlet?ID=<%=ID%>&cmd=GetProtocols&subtype='+subtype;		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.protocols;
}

function getSoftware(subtype)
{
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading ' + subtype + ' hardware...');
		var url = '../Software.servlet?ID=<%=ID%>&cmd=GetSoftware&subtype='+subtype;		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.software;
}

function getClusters()
{
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading Open Grid Scheduler clusters...');
		var url = '../OpenGrid.servlet?ID=<%=ID%>&cmd=GetHostInfo';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.clusters;
}

function clusterOnChange()
{
	var frm = document.forms['reggie'];
	
	var cluster = frm.clusters[frm.clusters.selectedIndex].cluster;
	if (cluster.priorities && cluster.priorities.length > 0)
	{
		frm.priority.length = 0;
		for (var pNo = 0; pNo < cluster.priorities.length; pNo++)
		{
			var p = cluster.priorities[pNo];
			frm.priority[frm.priority.length] = new Option(p.name + ' ('+p.value+')', p.value, p['default']);
		}
		Main.show('job-priority');
	}
	else
	{
		Main.hide('job-priority');
	}
}


function goRegister()
{
	if (!step2IsValid()) return;

	var frm = document.forms['reggie'];
	
	frm.maskingSoftware.disabled = true;
	frm.maskingProtocol.disabled = true;
	frm.alignSoftware.disabled = true;
	frm.alignProtocol.disabled = true;
	frm.priority.disabled = true;
	frm.debug.disabled = true;
	
	Main.addClass(document.getElementById('step.2.section'), 'disabled');
	
	Main.hide('goregister');
	Main.hide('gocancel');
	Main.hide('gonext.message');
	
	var submitInfo = {};
	
	submitInfo.maskingSoftware = parseInt(frm.maskingSoftware.value);
	submitInfo.maskingProtocol = parseInt(frm.maskingProtocol.value);
	submitInfo.alignSoftware = parseInt(frm.alignSoftware.value);
	submitInfo.alignProtocol = parseInt(frm.alignProtocol.value);
	submitInfo.cluster = frm.clusters.value;
	if (frm.priority.selectedIndex >= 0)
	{
		submitInfo.priority = parseInt(frm.priority.value);
	}
	submitInfo.debug = frm.debug.checked;
	
	var mergedSequences = [];
	submitInfo.mergedSequences = mergedSequences;
	
	for (var msNo = 0; msNo < frm.mergedSequences.length; msNo++)
	{
		if (frm.mergedSequences[msNo].selected) 
		{
			var ms = {};
			ms.id = frm.mergedSequences[msNo].mergedSequences.id;
			mergedSequences[mergedSequences.length] = ms;
		}
	}
	
	if (debug) Main.debug(JSON.stringify(submitInfo));
	var url = '../MaskAlign.servlet?ID=<%=ID%>&cmd=StartMaskingAndAlignment';
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Performing registration...');
		request.open("POST", url, false);
		request.send(JSON.stringify(submitInfo));
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);
	
	if (response.messages && response.messages.length > 0)
	{
		var msg = '<ul>';
		for (var i = 0; i < response.messages.length; i++)
		{
			var msgLine = response.messages[i];
			if (msgLine.indexOf('[Warning]') >= 0)
			{
				msg += '<li class="warning">' + msgLine.replace('[Warning]', '');
			}
			else
			{
				msg += '<li>' + msgLine;
			}
		}
		msg += '</ul>';
		setInnerHTML('messages', msg);
		Main.show('messages');
	}
	
	if (response.status != 'ok')
	{
		Main.addClass(document.getElementById('messages'), 'failure');
		setFatalError(response.message);
		return false;
	}

	Main.show('gorestart');	
}


var subtypeMergedSequences = null;
function selectMergedSequences()
{
	var frm = document.forms['reggie'];
	if (frm.mergedSequences.disabled) return;
	
	if (subtypeMergedSequences == null)
	{
		var request = Ajax.getXmlHttpRequest();
		var url = '../Subtype.servlet?ID=<%=ID%>&cmd=GetSubtypeInfo&name=MERGED_SEQUENCES';
		request.open("GET", url, false);	
		request.send(null);

		if (debug) Main.debug(request.responseText);
		var response = JSON.parse(request.responseText);	
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		subtypeMergedSequences = response.subtype;
	}
	
	var url = getRoot() + 'views/derivedbioassays/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=setMergedSequencesCallback';
	url += '&tmpfilter:INT:itemSubtype='+subtypeMergedSequences.id;
	Main.openPopup(url, 'SelectMergedSequences', 1000, 700);
}

function setMergedSequencesCallback(id, name)
{
	var frm = document.forms['reggie'];
	var mergedSequences = frm.mergedSequences;
	for (var i = 0; i < mergedSequences.length; i++)
	{
		if (mergedSequences[i].value == id)
		{
			mergedSequences[i].selected = true;
			setInputStatus('mergedSequences', '', '');
			return;
		}
	}

	var ms = {};
	ms.id = id;
	ms.name = name;
	
	var option = new Option(name, id);
	option.mergedSequences = ms;
	option.selected = true;
	mergedSequences[mergedSequences.length] = option;
	setInputStatus('mergedSequences', '', '');
}

</script>
<style>

</style>
</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Start filter and alignment" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>
	
	<div class="allsteps">
		<div class="step current" id="step.1">1</div>
		›
		<div class="step future" id="step.2">2</div>
	</div>

	<form name="reggie" onsubmit="return false;">
	
	<div id="step.1.section">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select merged sequences</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table style="border-collapse: collapse;">
			<tr valign="top">
				<td class="prompt">Merged sequences</td>
				<td class="input"><select class="required" style="width:90%;" multiple size="30"
						name="mergedSequences" id="mergedSequences"></select>
						
					<base:buttongroup style="margin-top: 0.5em;">
						<base:button title="Select manually&hellip;" onclick="selectMergedSequences()" id="btnSelectMergedSequences" />
					</base:buttongroup>
				</td>
				<td class="status" id="mergedSequences.status"></td>
				<td class="help"><span id="mergedSequences.message" class="message" style="display: none;"></span>
					Select the sequences that should be aligned. The list contains all merged sequences that
					has not yet been aligned.<br><br>
					Items marked with <b>[R]</b> have been marked for re-alignment due to a failure of
					a previous alignment.
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
	
	<div id="step.2.section" style="display: none;">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">2</td>
		<td class="steptitle" id="step.2.title">Masking and alignment information</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table style="border-collapse: collapse;">
			<tr valign="top" style="background-color: #E8E8E8;">
				<td class="prompt">Masking</td>
				<td class="input"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Software</td>
				<td class="input"><select style="width:90%" name="maskingSoftware" id="maskingSoftware" 
					onkeypress="focusOnEnter(event, 'maskingProtocol')"></select></td>
				<td class="status" id="maskingSoftware.status"></td>
				<td class="help"><span id="maskingSoftware.message" class="message" style="display: none;"></span>
					Select the software to use for masking.
				</td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Protocol</td>
				<td class="input"><select style="width:90%" name="maskingProtocol" id="maskingProtocol" 
					onkeypress="focusOnEnter(event, 'alignSoftware')"></select></td>
				<td class="status" id="maskingProtocol.status"></td>
				<td class="help"><span id="maskingProtocol.message" class="message" style="display: none;"></span>
					Select the protocol used for filtering.
				</td>
			</tr>
			<tr valign="top" style="background-color: #E8E8E8;">
				<td class="prompt">Align</td>
				<td class="input"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Software</td>
				<td class="input"><select style="width:90%" name="alignSoftware" id="alignSoftware" 
					onkeypress="focusOnEnter(event, 'alignProtocol')"></select></td>
				<td class="status" id="alignSoftware.status"></td>
				<td class="help"><span id="alignSoftware.message" class="message" style="display: none;"></span>
					Select the software to use for alignment.
				</td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Protocol</td>
				<td class="input"><select style="width:90%" name="alignProtocol" id="alignProtocol" 
					onkeypress="focusOnEnter(event, 'clusters')"></select></td>
				<td class="status" id="alignProtocol.status"></td>
				<td class="help"><span id="alignProtocol.message" class="message" style="display: none;"></span>
					Select the protocol used for alignment.
				</td>
			</tr>
			<tr valign="top" style="background-color: #E8E8E8;">
				<td class="prompt">Open Grid Scheduler</td>
				<td class="input"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Cluster</td>
				<td class="input"><select style="width:90%" name="clusters" id="clusters" class="required"
					onchange="clusterOnChange()"
					></select></td>
				<td class="status" id="clusters.status"></td>
				<td class="help"><span id="clusters.message" class="message" style="display: none;"></span>
					Select the cluster to use for running the software.
				</td>
			</tr>
			<tr valign="top" id="job-priority" style="display: none;">
				<td class="subprompt">Job priority</td>
				<td class="input"><select style="width:90%" name="priority" id="priority"></select></td>
				<td class="status" id="priority.status"></td>
				<td class="help"><span id="priority.message" class="message" style="display: none;"></span>
					Select the priority of the job.
				</td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Debug</td>
				<td class="input"><input type="checkbox" name="debug"></td>
				<td class="status" id="debug.status"></td>
				<td class="help"><span id="debug.message" class="message" style="display: none;"></span>
					When running in debug mode only part of the sequenced data is used and
					temporary files are not removed from the cluster node.
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
		
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="messages" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)"/></td>
			<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>" onclick="goRegister()" style="display: none;"/></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>