var Xport = function()
{
	var xport = {};
	var previewTitle;
	var previewList;
	
	xport.initPage = function()
	{
		previewTitle = Doc.element('previewTitle');
		previewList = Doc.element('previewList');
		
		Buttons.addClickHandler('goexport', xport.goExport);
		Buttons.addClickHandler('gopreview', xport.goPreview);
	}
	
	xport.goPreview = function()
	{
		xport.doExport(true);
	}
	
	xport.goExport = function()
	{
		xport.doExport(false);
	}
	
	xport.doExport = function(preview)
	{
		var frm = document.forms['reggie'];
		var url = '../Export.servlet?ID='+App.getSessionId();
		url += '&cmd=ExportMonthlyOpList';
		url += '&time=' + frm.time.value;
		url += '&exportSubtype=0';
		url += '&exportPatientId=0';

		if (preview) 
		{
			Doc.hide('previewWrapper');
			previewTitle.innerHTML = 'Working...';
			previewList.innerHTML = '';
			
			url += '&preview=1';
			showLoadingAnimation('Working...');
			var request = Ajax.getXmlHttpRequest();
			request.open("GET", url, true);	
			Ajax.setReadyStateHandler(request, xport.onPreviewLoaded, xport.onPreviewLoaded);
			request.send(null);
		}
		else
		{
			window.location = url;		
		}
	}

	xport.onPreviewLoaded = function(request)
	{
		hideLoadingAnimation();
		if (request.status != 200)
		{
			var win = Dialogs.openPopup('', 'ErrorWindow', 800, 600);
			win.document.write(request.responseText);
			return;
		}
		
		var frm = document.forms['reggie'];
		var allLines = request.responseText.split('\n');
		var numCases = allLines.length - 2; // First line is a header line
		
		var html = '<tr><th>'+allLines[0].replace(/\t/g, '</th><th>')+'</th></tr>';
		// Check last column for the 'Consent' value. All should be 'YES' for the export to be ok.
		var numNoConsent = 0;
		var numMissingConsent = 0;
		for (var i = 1 ; i <= numCases; i++)
		{
			var line = allLines[i];
			var cols = line.split(/\t/);
			var consent = cols[cols.length-1];
			var rowClass = '';
			if (consent != 'YES')
			{
				rowClass = 'consent-warning';
				if (consent == 'MISSING')
				{
					numMissingConsent++;
				}
				else
				{
					numNoConsent++;
				}
			}
			html += '<tr class="'+rowClass+'"><td>'+cols.join('</td><td>')+'</td></tr>';
		}
		
		var previewWarning = Doc.element('previewWarning');
		if (numMissingConsent > 0 || numNoConsent > 0)
		{
			var warning = '<img src="../images/warning.png" alt="!">';
			warning += ' Found ' + (numNoConsent+numMissingConsent) + ' case(s) with denied or missing consent!';
			previewWarning.innerHTML = warning;
		}
		else
		{
			previewWarning.innerHTML = '';
		}
		
		previewTitle.innerHTML = 'Operation dates - ' + frm.time[frm.time.selectedIndex].text + ' (' + numCases + ')';
		previewList.innerHTML = '<table>'+html+'</table>';
		Doc.show('previewWrapper');
	}
	
	return xport;
}();

Doc.onLoad(Xport.initPage);

